<template>
  <v-select
    :items="users"
    :value="value"
    @change="updateUser"
    :label="label"
    item-text="forename"
    item-value="id"
    return-object
    autocomplete
    clearable
  >
  </v-select>
</template>

<script>
import { find } from "lodash";
import HTTP from "../../common/HTTP";

export default {
  props: ["value", "label"],
  data() {
    return {
      users: [],
    };
  },
  created() {
    this.fetchUsers();
  },
  watch: {
    value(newValue) {
      if (typeof newValue === "string") {
        const userObj = find(this.users, { id: newValue });
        this.updateUser(userObj);
      }
    },
  },
  methods: {
    fetchUsers() {
      HTTP.get("users/?deleted=false").then(({ data: { content } }) => {
        this.users = content;
      });
    },
    updateUser(user) {
      this.$emit("input", user.id);
    },
  },
};
</script>
